clear
param

global tolK dumpK

tolK=1e-4;
dumpK=0.88;

T=100;
nk=100;
ng=100;

Kss=5.6;
[r,w]=aggvars(Kss,L);

k=uniformnodes(ka,kb,nk);
kd=uniformnodes(ka,kb,ng);
c0=0.8*income(k,w,r);

% Initial steady state

tic
[Kss0,out0]=ridders('equiobj',4,9,1e-5,c0,k,kd);
toc

[r0,w0]=aggvars(Kss0,L);
L0=L;
% ------------------------------------------------------------------------
% policy change

phi=1.01;

% ------------------------------------------------------------------------
% Final steady state

tic
[KssT,outT]=ridders('equiobj',3,15,1e-5,out0{1},k,kd);
toc

% Transition

K=uniformnodes(Kss0,KssT,T);
N=uniformnodes(L0,L,T);

tic
[C,LAMBDA,K,N,R,W]=transition_solve(K,N,k,kd,out0,outT,r0,w0);
toc

save transition C LAMBDA K N R W k kd T Kss0 KssT out0 outT

transition_results