function [C,LAMBDA,K,N,R,W]=transition_solve(K,N,k,kd,out0,outT,r0,w0)

global dumpK tolK

T=length(K);
C=cell(T,1);
LAMBDA=cell(T,1);

C{1}=out0{1};
C{T}=outT{1};
LAMBDA{1}=out0{2};
LAMBDA{T}=outT{2};

dif=1;
while dif>tolK
    
    [R,W]=aggvars(K,N);
    R(1)=r0;
    W(1)=w0;
    C=transition_policy(C,R,W,k);
    [LAMBDA,K1,N1]=transition_dist(LAMBDA,C,K,N,R,W,k,kd);
    dif=max(abs(K1-K));
    disp(dif);
    K=dumpK*K+(1-dumpK)*K1;
    N=dumpK*N+(1-dumpK)*N1;
    
end

end

% ------------------------------------------------------------------------

function C=transition_policy(C,R,W,k)

global dump tol

T=length(R);

for t=T-1:-1:2
    
    C{t}=C{t+1};

    dif=1;
    while dif>tol
        
        YT=income(k,W(t),R(t));
        c=eulereq(C{t},C{t+1},k,YT,R(t+1));
        dif=maxn(abs(c-C{t}));
        C{t}=dump*c+(1-dump)*C{t};
        
    end
    
end

end

% ------------------------------------------------------------------------

function [LAMBDA,K,N]=transition_dist(LAMBDA,C,K,N,R,W,k,kd)

global lab P type ka

T=length(R);
K1=cell(T-1,1);

for t=1:T-1
    
    Yd=income(kd,W(t),R(t));
    
    if (size(k)~=size(kd))
        Cd=interp1(k,C{t},kd,type);
        K1{t}=max(Yd-Cd,ka);
    else
        K1{t}=max(Yd-C{t},ka);
    end
    
end

for t=1:T-2
    
    Q=Qmatrix1(kd,K1{t},P);
    LAMBDA{t+1}=reshape(Q.'*LAMBDA{t}(:),size(LAMBDA{t}));
    K(t+1)=sum(sum(bsxfun(@times,full(LAMBDA{t}),K1{t})));
    N(t+1)=sum(sum(bsxfun(@times,full(LAMBDA{t+1}),lab)));
    
end

end